package com.jiuqi.util.patterns;

import java.util.Map;

interface IPattern
{
    public static final int CONST = 0;
    public static final int VARIABLE = 1;
    public static final int PLACEHODER = 2;
    
    int getType();
    
    int size();
    
    IPattern get(final int p0);
    
    void add(final IPattern p0);
    
    void add(final int p0, final IPattern p1);
    
    void remove(final int p0);
    
    int indexOf(final IPattern p0);
    
    void clear();
    
    String getExpression();
    
    void setExpression(final String p0);
    
    int getLength();
    
    void setLength(final int p0);
    
    int match(final String p0, final int p1, final Map p2);
    
    String replace(final ITranslator p0);
}
